package jacob.tool;

import ccl.util.Util;

import jacob.tool.JacobInterface;
import jacob.tool.JacobRunnable;

/**
 * This class exists just for convenience
 * reasons.
 * 
 * @author  <a href="http://mats.gmd.de/clemens/">Chr. Clemens Lahme</a> (<a href="mailto:clemens.lahme@mailexcite.com"><i>Clemens.Lahme@mailexcite.com</i></a>)
 * @version $Id: WrapperAdapter.java,v 1.3 1998/12/18 12:39:21 clemens Exp clemens $
 */
public abstract class WrapperAdapter implements JacobRunnable {
    protected JacobInterface _pJacobInterface = null;

    public WrapperAdapter() {
        super();
    }

    /*
     * --- implemented methods of class 'jacob.tool.JacobRunnable' ---
     */
    
    public void set(JacobInterface pJacobInterface_) {
        Util.panicIf(pJacobInterface_ == null);
        _pJacobInterface = pJacobInterface_;
    }
    
    public String toString() {
        String sRetVal = getClass().getName();
        sRetVal = sRetVal.substring(sRetVal.lastIndexOf('.') + 1);
        if (Util.endsWith(sRetVal, "Wrapper")) {
            sRetVal = sRetVal.substring(0, sRetVal.length() - 7);
        }
        
        return sRetVal;
    }
    
    public void run() {
        // just in case someone does extend this
        // class but does not override this
        // method, so it gets stopped.
        _pJacobInterface.stopped(this);
    }
}
